let flat_map f l =
  let rec fmap accu = function
    [] -> accu
  | a :: l -> fmap (List.rev_append (f a) accu) l
  in fmap [] l

let rec truncate n = function
    [] -> []
  | a :: l -> if n <= 0 then [] else a :: truncate (n-1) l
