type token =
    Blank of char
  | Char of char
  | Opening of tag
  | Closing of tag
  | EOF

and tag =
    B | EM | I | PL | S | TT | U
  | Size of char
  | Color of char

val token: Lexing.lexbuf -> token

exception Lexical_error of string
